/*
 * db_creator.h
 *
 *  Created on: 2009/10/06
 *      Author: shu
 */

#ifndef DB_CREATOR_H_
#define DB_CREATOR_H_

#include "sequence.h"
#include "sequence_reader.h"
#include "encoder.h"
#include "db_creator_parameters.h"
#include <vector>
#include <string>
#include <stdint.h>
#include <limits.h>

using namespace std;

class DbCreator {
public:
  DbCreator() {
  }

  void Run(const DbCreatorParameters &paramters);

private:
  void ReadSequences(uint32_t max_chunk_sequences_length,
      vector<SequencePtr> &sequences);

  void Encode(vector<SequencePtr> &sequences, const SequenceType &sequence_type,
      Code **encoded_sequences, uint32_t *sequences_length,
      uint32_t **positions);

  void SaveChunkInformation(string chunk_name, uint32_t number_sequences,
      uint32_t sequences_data_length);

  void SaveNames(string chunk_name, vector<SequencePtr> &sequences);

  void SaveSequences(string chunk_name, Code sequences_data[],
      uint32_t sequences_data_length);

  void SavePositions(string chunk_name, uint32_t positions[],
      uint32_t number_sequences);

  void SaveIndex(string chunk_name, const SequenceType &sequence_type, Code sequences_data[], uint32_t sequences_data_length, uint32_t max_cached_offset);

  void SaveDbInformation(string db_name, uint32_t number_chunks,
      uint32_t max_length, uint64_t db_length, uint64_t number_sequences);

  SequenceReaderPtr reader_;
  SequencePtr next_sequence_;

};

#endif /* DB_CREATOR_H_ */
